unit OpenGL_Ex;

interface

uses
  Windows, OpenGL;

type
  GLHandleARB = Integer;



//       OpenGL.pas
const
// Textures
  GL_MAX_TEXTURE_UNITS_ARB          = $84E2;
  GL_MAX_TEXTURE_SIZE               = $0D33;
  GL_CLAMP_TO_EDGE                  = $812F;
  GL_LUMINANCE8                     = $8040;
  GL_RGB8                           = $8051;
  GL_RGBA8                          = $8058;
  GL_BGR                            = $80E0;
  GL_BGRA                           = $80E1;
  GL_TEXTURE0_ARB                   = $84C0;
  GL_TEXTURE1_ARB                   = $84C1;
  GL_TEXTURE_MAX_ANISOTROPY_EXT     = $84FE;
  GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT = $84FF;
  GENERATE_MIPMAP_SGIS              = $8191;
 
// AA
  WGL_SAMPLE_BUFFERS_ARB = $2041;
  WGL_SAMPLES_ARB	 = $2042;
  WGL_DRAW_TO_WINDOW_ARB = $2001;
  WGL_SUPPORT_OPENGL_ARB = $2010;
  WGL_DOUBLE_BUFFER_ARB  = $2011;
  WGL_COLOR_BITS_ARB     = $2014;
  WGL_DEPTH_BITS_ARB     = $2022;
  WGL_STENCIL_BITS_ARB   = $2023;

// FBO
  GL_FRAMEBUFFER_EXT          = $8D40;
  GL_RENDERBUFFER_EXT         = $8D41;
  GL_DEPTH_COMPONENT24_ARB    = $81A6;
  GL_COLOR_ATTACHMENT0_EXT    = $8CE0;
  GL_DEPTH_ATTACHMENT_EXT     = $8D00;
  GL_FRAMEBUFFER_BINDING_EXT  = $8CA6;
  GL_FRAMEBUFFER_COMPLETE_EXT = $8CD5;

// Shaders
  GL_VERTEX_SHADER_ARB          = $8B31;
  GL_FRAGMENT_SHADER_ARB        = $8B30;
  GL_OBJECT_COMPILE_STATUS_ARB  = $8B81;
  GL_OBJECT_LINK_STATUS_ARB     = $8B82;

// VBO
  GL_ARRAY_BUFFER_ARB         = $8892;
  GL_ELEMENT_ARRAY_BUFFER_ARB = $8893;
  GL_STATIC_DRAW_ARB          = $88E4;
  GL_NORMAL_ARRAY             = $8075;
  GL_COLOR_ARRAY              = $8076;
  GL_VERTEX_ARRAY             = $8074;
  GL_TEXTURE_COORD_ARRAY      = $8078;
  GL_WRITE_ONLY_ARB           = $88B9;


  procedure glGenTextures(n: GLsizei; textures: PGLuint); stdcall; external opengl32;
  procedure glBindTexture(target: GLenum; texture: GLuint); stdcall; external opengl32;
  procedure glDeleteTextures(N: GLsizei; Textures: PGLuint); stdcall; external opengl32;
  function glIsTexture(texture: GLuint): GLboolean; stdcall; external opengl32;
  procedure glCopyTexImage2D(target: GLEnum; level: GLint; internalFormat: GLEnum; x, y: GLint; width, height: GLsizei; border: GLint); stdcall; external opengl32;
  function wglGetCurrentDC():DWORD; stdcall; external opengl32;
var
// VSync
  WGL_EXT_swap_control  : Boolean;
  wglSwapIntervalEXT    : function (interval: GLint): Boolean; stdcall;
  wglGetSwapIntervalEXT : function: GLint; stdcall;

// MultiTexture
  GL_ARB_multitexture      : Boolean;
  glActiveTextureARB       : procedure (texture: Cardinal); stdcall;
  glClientActiveTextureARB : procedure (texture: Cardinal); stdcall;

// FrameBuffer
  GL_EXT_framebuffer_object    : Boolean;
  glGenRenderbuffersEXT        : procedure (n: GLsizei; renderbuffers: PGLuint); stdcall;
  glDeleteRenderbuffersEXT     : procedure (n: GLsizei; const renderbuffers: PGLuint); stdcall;
  glBindRenderbufferEXT        : procedure (target: GLenum; renderbuffer: GLuint); stdcall;
  glRenderbufferStorageEXT     : procedure (target: GLenum; internalformat: GLenum; width: GLsizei; height: GLsizei); stdcall;
  glGenFramebuffersEXT         : procedure (n: GLsizei; framebuffers: PGLuint); stdcall;
  glDeleteFramebuffersEXT      : procedure (n: GLsizei; const framebuffers: PGLuint); stdcall;
  glBindFramebufferEXT         : procedure (target: GLenum; framebuffer: GLuint); stdcall;
  glFramebufferTexture2DEXT    : procedure (target: GLenum; attachment: GLenum; textarget: GLenum; texture: GLuint; level: GLint); stdcall;
  glFramebufferRenderbufferEXT : procedure (target: GLenum; attachment: GLenum; renderbuffertarget: GLenum; renderbuffer: GLuint); stdcall;
  glCheckFramebufferStatusEXT  : function (target: GLenum): GLenum; stdcall;

// Shaders
  GL_ARB_shading_language   : Boolean;
  glDeleteObjectARB         : procedure (Obj: GLHandleARB); stdcall;
  glCreateProgramObjectARB  : function: GLHandleARB; stdcall;
  glCreateShaderObjectARB   : function (shaderType: GLEnum): GLHandleARB; stdcall;
  glShaderSourceARB         : procedure (shaderObj: GLHandleARB; count: GLSizei; src: Pointer; len: Pointer); stdcall;
  glAttachObjectARB         : procedure (programObj, shaderObj:GLhandleARB); stdcall;
  glLinkProgramARB          : procedure (programObj: GLHandleARB); stdcall;
  glUseProgramObjectARB     : procedure (programObj:GLHandleARB); stdcall;
  glCompileShaderARB        : function (shaderObj: GLHandleARB): GLboolean; stdcall;
  glGetObjectParameterivARB : procedure (Obj: GLHandleARB; pname: GLEnum; params: PGLuint); stdcall;
  glGetAttribLocationARB    : function (programObj: GLhandleARB; const char: PChar): GLInt; stdcall;
  glGetUniformLocationARB   : function (programObj:GLhandleARB; const char: PChar): GLInt; stdcall;
  glVertexAttrib1fARB       : procedure (index: GLuint; x: GLfloat); stdcall;
  glVertexAttrib2fARB       : procedure (index: GLuint; x, y: GLfloat); stdcall;
  glVertexAttrib3fARB       : procedure (index: GLuint; x, y, z: GLfloat); stdcall;

  glUniform1iARB            : procedure (location: GLint; v0: GLint); stdcall;
  glUniform1ivARB           : procedure (location: GLint; count: GLsizei; value: PGLint); stdcall;
  glUniform2ivARB           : procedure (location: GLint; count: GLsizei; value: PGLint); stdcall;
  glUniform3ivARB           : procedure (location: GLint; count: GLsizei; value: PGLint); stdcall;
  glUniform4ivARB           : procedure (location: GLint; count: GLsizei; value: PGLint); stdcall;
  glUniform1fvARB           : procedure (location: GLint; count: GLsizei; value: PGLfloat); stdcall;
  glUniform2fvARB           : procedure (location: GLint; count: GLsizei; value: PGLfloat); stdcall;
  glUniform3fvARB           : procedure (location: GLint; count: GLsizei; value: PGLfloat); stdcall;
  glUniform4fvARB           : procedure (location: GLint; count: GLsizei; value: PGLfloat); stdcall;
  glUniformMatrix2fvARB     : procedure (location: GLint; count: GLsizei; transpose: GLboolean; value: PGLfloat); stdcall;
  glUniformMatrix3fvARB     : procedure (location: GLint; count: GLsizei; transpose: GLboolean; value: PGLfloat); stdcall;
  glUniformMatrix4fvARB     : procedure (location: GLint; count: GLsizei; transpose: GLboolean; value: PGLfloat); stdcall;

  glGetInfoLogARB : procedure(shaderObj: GLHandleARB; maxLength: glsizei; var length: glint; infoLog: PChar); stdcall;

// Vertex Buffer Object
  GL_ARB_vertex_buffer_object : Boolean;
  glBindBufferARB    : procedure (target: GLenum; buffer: GLenum); stdcall;
  glDeleteBuffersARB : procedure (n: GLsizei; const buffers: PGLuint); stdcall;
  glGenBuffersARB    : procedure (n: GLsizei; buffers: PGLuint); stdcall;
  glBufferDataARB    : procedure (target: GLenum; size: GLsizei; const data: PGLuint; usage: GLenum); stdcall;
  glBufferSubDataARB : procedure (target: GLenum; offset: GLsizei; size: GLsizei; const data: PGLuint); stdcall;
  glMapBufferARB     : function  (target: GLenum; access: GLenum): Pointer; stdcall;
  glUnmapBufferARB   : function  (target: GLenum): GLboolean; stdcall;

  procedure glNormalPointer(type_: GLenum; stride: Integer; const P: PGLuint); stdcall; external opengl32;
  procedure glColorPointer(size: Integer; _type: GLenum; stride: Integer; const _pointer: PGLuint); stdcall; external opengl32;
  procedure glVertexPointer(size: Integer; _type: GLenum; stride: Integer; const _pointer: PGLuint); stdcall; external opengl32;
  procedure glTexCoordPointer(size: Integer; _type: GLenum; stride: Integer; const _pointer: PGLuint); stdcall; external opengl32;

  procedure glInterleavedArrays  (format: GLenum; stride: GLsizei; const _pointer: PGLuint); stdcall; external opengl32;
  procedure glEnableClientState  (_array: GLenum); stdcall; external opengl32;
  procedure glDisableClientState (_array: GLenum); stdcall; external opengl32;
  procedure glDrawElements       (mode: GLenum; count: GLsizei; _type: GLenum; const indices: PGLuint); stdcall; external opengl32;
  procedure glDrawArrays         (mode: GLenum; first, count: GLsizei); stdcall; external opengl32;

  //   (WGL_ARB_multisample)
  function WGLisExtensionSupported(const extension: string): boolean;

  //   
  function GetTime: Integer;


implementation

function WGLisExtensionSupported;           
var
  wglGetExtString: function(hdc: HDC): Pchar; stdcall; 
  supported: PChar;
begin
  wglGetExtString := nil;
  supported := nil;
  wglGetExtString := wglGetProcAddress('wglGetExtensionsStringARB');          
  if Assigned(wglGetExtString) then                                             
    supported := wglGetExtString(wglGetCurrentDC());
  if supported = nil then                                               
    supported := glGetString(GL_EXTENSIONS);
  if supported = nil then                                   
    begin
    Result := false;
    exit;
    end;
  if Pos(extension,supported) = 0 then                           
    begin
    Result := false;                                             
    exit;                                                            
    end;
  Result := true;                                                       
end;

function GetTime;
var
  T : LARGE_INTEGER;
  F : LARGE_INTEGER;
begin
  QueryPerformanceFrequency(Int64(F));
  QueryPerformanceCounter(Int64(T));
  Result := Trunc(1000 * T.QuadPart / F.QuadPart);
end;

end.
